# KED:  Wellcome to Kerem and Edwin's Develeppoment platform.

# This branch is for testing and is organised as follow :
## Goal is to emulate KED as it would be a submodule 
## Tree View
```
├── examples
│   └── pin_control.c
├── ked
│   ├── CMakeLists.txt
│   └── peripherals
│       └── gpio
│           └── gpio.h
└── peripherals
    └── gpio
        └── gpio.c
```
## Dependencies
``` sudo apt install libgpiod-dev ```

# To Compile from root of project

## Prepeare for MAKE

```cmake -S ked -B build -DMAIN_FILE=examples/pin_control.c```
this will also create the build diretory for you. 

## MAKE

```cd build```

```make```

## RUN
```./ked_executable -pin 21 -dir out -set```
Will set GPIO21 pin (HEADER 40) to High

#Size Difference with Pointers, don't forget tha tin an MCU envoiroment it will also execute faster. 

```
With Pointers
text	   data	    bss	    dec	    hex	filename
3812	    340	     16	   4168	   1048	ked_executable

Without Pointer
text	   data	    bss	    dec	    hex	filename
3692	    332	     16	   4040	    fc8	ked_executable ```


